3 # Copyright (c) 2000-2002 Timothy M. King (tmk@lordzork.com)
5 # Permission is hereby granted, free of charge, to any person obtaining a
6 # copy of this software and associated documentation files (the "Software"),
7 # to deal in the Software without restriction, including without limitation
8 # the rights to use, copy, modify, merge, publish, distribute, sublicense,
9 # and/or sell copies of the Software, and to permit persons to whom the
10 # Software is furnished to do so, subject to the following conditions:
12 # The above copyright notice and this permission notice shall be included in
13 # all copies or substantial portions of the Software.
15 # THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
16 # IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
17 # FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
18 # THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
19 # LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
20 # FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
21 # DEALINGS IN THE SOFTWARE.
23 PATH
=$PATH:/usr
/bin
:/usr
/local
/bin
:/usr
/X
11R
6/bin
25 img_apps
="display xli xsetbg Esetroot qiv wmsetbg xv"
27 display_full_cmd
="display -geometry 800x600 -window root"
28 display_tile_cmd
="display -window root"
29 display_center_cmd
="display -backdrop -window root"
30 display_default_cmd
="$display_center_cmd"
32 Esetroot_full_cmd
="Esetroot -scale"
33 Esetroot_tile_cmd
="Esetroot"
34 Esetroot_center_cmd
="Esetroot -c"
35 Esetroot_default_cmd
="$Esetroot_center_cmd"
37 wmsetbg_full_cmd
="wmsetbg -s -S"
38 wmsetbg_tile_cmd
="wmsetbg -t"
39 wmsetbg_center_cmd
="wmsetbg -e"
40 wmsetbg_default_cmd
="$wmsetbg_center_cmd"
42 qiv_full_cmd
="qiv --root_s"
43 qiv_tile_cmd
="qiv --root_t"
44 qiv_center_cmd
="qiv --root"
45 qiv_default_cmd
="$qiv_center_cmd"
47 xv_full_cmd
="xv -max -smooth -root -quit"
48 xv_tile_cmd
="xv -root -quit"
49 xv_center_cmd
="xv -rmode 5 -root -quit"
50 xv_default_cmd
="$xv_center_cmd"
52 xli_full_cmd
="xli -fullscreen -onroot -quiet"
53 xli_tile_cmd
="xli -onroot -quiet"
54 xli_center_cmd
="xli -center -onroot quiet"
55 xli_default_cmd
="$xli_center_cmd"
57 xsetbg_full_cmd
="xsetbg -fullscreen"
58 xsetbg_tile_cmd
="xsetbg"
59 xsetbg_center_cmd
="xsetbg -center"
60 xsetbg_default_cmd
="$xsetbg_center_cmd"
62 ##################################
66 copyright
="(c) 2000-$(date +%Y) by Timothy M. King (http://lordzork.com/)"
67 config
=$HOME/.bsetbgrc
68 last_cmd_file
=$HOME/.bsetbg_last_cmd
74 [ "$1" ] && rc
=$1 && shift 1
75 [ "$*" ] && echo -e $
*
81 [yY
][eE
][sS
]|1|[yY
]|[tT
][rR
][uU
][eE
]|[oO
][nN
]) : ;;
90 elif [ -x "$(which $1 2>/dev/null)" ]; then
92 elif [ -x "$(type $1 2>/dev/null)" ]; then
102 $me $version $copyright
104 -center <file> center an image on the desktop
105 -tile <file> tile an image on the desktop
106 -full <file> stretch an image to fill the desktop
107 -exec <args> <file> specify an external command to execute
109 -post <string> arguments to be passed to the post-command
110 -debug prints commands without executing them
113 # this is extremely lame, but probably more portable than grep -E
114 bsetroot_help
=$(bsetroot -help 2>&1| grep -v "^bsetroot" | grep -v "^ -help")
115 case $bsetroot_help in
116 BaseDisplay
*) echo ;;
117 *-gradient*) echo "$bsetroot_help"
121 -generate <string> generate a config file
123 -version output version information
130 for a
in $img_apps; do
131 if check_exe_in_path
$a; then
132 eval center_cmd
=\$
$a\_center_cmd
133 eval full_cmd
=\$
$a\_full_cmd
134 eval tile_cmd
=\$
$a\_tile_cmd
135 eval default_cmd
=\$
$a\_default_cmd
138 if [ "$not_found" ]; then
139 not_found
="$not_found $a"
150 echo -e "# created by $me $version on $(date)\n#"
151 echo -e "# seting NO_EXEC to a boolean value (eg true/false) will cause $me"
152 echo -e "# to never modify the root window\n#"
153 echo -e "#NO_EXEC=\n#"
154 echo -e "# POST_COMMAND can be set to a command that will be run run every time"
155 echo -e "# $me sets the root image\n#"
156 echo -e "#POST_COMMAND=\n#"
157 echo -e "# if LOG_LAST_CMD is set (boolean), bsetbg will keep a log of the last"
158 echo -e "# two successful commands.\n#"
159 echo -e "#LOG_LAST_CMD=\n#"
160 echo -e "# the LOGFILE specifies the file that bsetbg uses when LOG_LAST_CMD"
161 echo -e "# is defined. this defaults to ~/.bsetbg_last_cmd .\n#"
162 echo -e "#LOGFILE=\n#"
163 echo -e "# the following are default configuration values for the most popular image"
164 echo -e "# programs. See the man page of the respective application for more info.\n"
166 [ "$*" ] && img_apps
="$*"
168 for a
in $img_apps; do
169 if check_exe_in_path
$a; then
170 if ! bool
$have_match; then
172 [ "$(eval echo \$$a\_center_cmd)" ] &&
173 eval echo CENTER
=$q\$
$a\_center_cmd
$q &&
175 [ "$(eval echo \$$a\_full_cmd)" ] &&
176 eval echo FULL
=$q\$
$a\_full_cmd
$q &&
178 [ "$(eval echo \$$a\_tile_cmd)" ] &&
179 eval echo TILE
=$q\$
$a\_tile_cmd
$q &&
181 [ "$(eval echo \$$a\_default_cmd)" ] &&
182 eval echo -e DEFAULT
=$q\$
$a\_default_cmd
$q \\\\n
&&
186 [ "$(eval echo \$$a\_center_cmd)" ] &&
187 eval echo \\#CENTER=$q\$$a\_center_cmd$q
189 [ "$(eval echo \$$a\_full_cmd)" ] &&
190 eval echo \\#FULL=$q\$$a\_full_cmd$q
192 [ "$(eval echo \$$a\_tile_cmd)" ] &&
193 eval echo \\#TILE=$q\$$a\_tile_cmd$q
195 [ "$(eval echo \$$a\_default_cmd)" ] &&
196 eval echo -e \\#DEFAULT=$q\$$a\_default_cmd$q \\\\n
205 if check_exe_in_path bsetroot
; then
208 $debug bsetroot $
* 2>/dev
/null
; rc
=$?
210 if [ "$rc" -gt 0 ]; then
213 log_cmd bsetroot $
*; $refresh_cmd 2>/dev
/null
216 quit
1 "couldn't find bsetroot in $PATH"
222 [ -z "$1" ] && help_msg
1
224 bool
$noconfig || read_config
227 check_img_command
$do_this
234 if [ -f "$file" ]; then
235 exec_img_command
$do_this $file
237 quit
1 "$file does not exist"
243 [ "$#" -lt 3 ] && help_msg
3
245 bool
$noconfig || read_config
247 # check to see if -*c, -*f, or -*t were spcified, if so
248 # assume the last argument is a filename
249 b_arg
=$(eval echo \$$(( $# - 1 )) )
253 -c|*-center|c
|-t|*-tile*|t
|-f|*-full|f
)
255 f_args
="$b_arg $file"
258 # put the rest of the arguments into the varialbe $e_args
263 *) e_args
="$e_args "$1""
269 # with $f_args defined, check for image and do things normally
270 if [ "$f_args" ]; then
271 [ ! -f "$file" ] && quit
1 "$file does not exist"
273 if check_img_command
$e_args; then
277 get_img_command
$f_args
278 check_img_command
$do_this
279 echo "$p couldn't find '$app' in path, using $type command instead"
281 # without $f_args, run the command blindly if it's in $PATH
282 elif check_exe_in_path
$e_args; then
285 quit
1 "$p unable to run the following command: $e_args"
288 exec_img_command
$do_this $file
294 *-full|-f|f
) type=full
; do_this
="$full_cmd" ;;
295 *-tile|-t|t
) type=tile
; do_this
="$tile_cmd" ;;
296 *-center|-c|c
) type=center
; do_this
="$center_cmd" ;;
297 *) type=default
; do_this
="$default_cmd"
303 if check_exe_in_path
$1; then
310 quit
1 "$p couldn't find a suitable image program. tried the following:\\n
311 $(for a in $not_found; do echo " $a\\n"; done)"
314 if [ "$rc" -gt 0 -a -z "$e_args" ] && bool
$read_config; then
315 echo "$p couldn't find a suitable $type command in $config"
326 if [ "$debug" ]; then
329 $command >/dev
/null
2>&1; rc
=$?
332 if [ "$rc" -gt 0 ]; then
333 echo "$p '$command' exited with status $rc"
336 parse_args
${f_args:-$my_args}
337 echo "$p using '$command' as $type"
338 $debug $command >/dev
/null
2>&1; rc
=$?
339 [ "$rc" = 0 ] && log_cmd
$do_this $file && $refresh_cmd 2>/dev
/null
341 log_cmd
$do_this $file; xrefresh
2>/dev
/null
348 bool
$LOG_LAST_CMD || return 1
349 [ "$debug" ] && return 1
350 echo -e "$prev_cmd\n$*" >$last_cmd_file
356 [ -f $config ] || return 1
358 if bool
$read_config; then
364 .
$HOME/.bsetbgrc
2>/dev
/null
371 last_cmd_file
=${LOGFILE:-$last_cmd_file}
373 bool
$LOG_LAST_CMD && prev_cmd
=$(tail -n 1 $last_cmd_file 2>/dev/null)
379 quit
0 "$p no_exec mode. the root window will not be modified."
384 if [ -n "$POST_COMMAND" -a "$rc" -le 0 ]; then
385 if [ -n "$debug" ]; then
386 $debug "running post_command: $POST_COMMAND $post_args"
388 post_command_output
=$($POST_COMMAND $post_args 2>&1); erc
=$?
389 if [ "$erc" -gt 0 ]; then
390 echo "$p post-command '$POST_COMMAND $post_args' exited with status $erc"
391 [ -n "$post_command_output" ] &&
392 echo "$POST_COMMAND $post_args: $post_command_output"
410 [ -z "$1" ] && return 1
411 if [ "$post_args" ]; then
412 post_args
="$post_args $1"
420 if [ -z "$command" ]; then
421 command=${2:-$1}; eval ${3:-${2:-$1}}=1
422 elif bool
$do_post; then
433 unset refresh_cmd
; debug
=echo\
$me\_debug
: ;;
436 unset finished do_standard do_exec
; do_post
=1 ;;
438 -c|*-center|c
|-t|*-tile*|t
|-f|*-full|f
)
440 do_standard
|do_generate
|do_bsetroot
)
443 if ! bool
$got_fcmd; then
444 add_arg
$1 args
; got_fcmd
=1
449 add_arg
$1; do_standard
=1; command=do_standard
452 -a|*-app|a
|-e|*-exec|e
)
453 check_cmd
"do_exec" ;;
455 -mod|-gradient|-solid|-display)
456 check_cmd
"do_bsetroot" && add_arg
$1 ;;
459 check_cmd
$1 "do_generate" ;;
462 [ -z "$command" ] && quit
0 $me $version $copyright ;;
465 [ -z "$command" ] && help_msg
;;
468 bool
$finished && return 1
471 bool
$do_exec || bool
$do_bsetroot || bool
$do_post || help_msg
1
474 if bool
$do_standard || bool
$do_exec || bool
$do_bsetroot || bool
$do_generate; then
476 elif bool
$do_post; then
479 add_arg
$1; command=do_standard
; finished
=1
484 [ -z "$*" ] && help_msg
1